import {
  findAll,
  addTaskSdk,
  delTaskSdk,
  deleteTask,
  updateTaskStatus,
  updateTaskName,
  getSdkArgs,
  saveTaskSdkRule,
  addTask,
  getRulesByTaskSdk,
  deleteTaskSdkRule,
  findByType,
  getTagList
} from "@/api/taskMange";
import { findAllSdk } from "@/api/device";

export default class TaskMange{
  public list1:Array<Object> = [];
  public list2:Array<Object> = [];
  public argsList:Array<Object> = [];
  public baseObject:any = {};
  public currentAlgoId:string = '';
  public currentTaskId:string = '';

  constructor(){
    this.list1 = [];
    this.list2 = [
      {
        id: "001",
        name: "任务1",
        child: [
          {
            id: "1",
            sdk_name: "人脸检测",
            isSelect: false
          },
          {
            id: "2",
            sdk_name: "人脸对比",
            isSelect: false
          }
        ],
        isSetting: false,
        isShowSetAlgo: false
      }
    ];
    this.argsList = [];
    this.baseObject = {
      id: '',
      algoId: '',
      options1: [],
      options2: [],
      options3: [],
      value1: '',
      value2: '',
      value3: '',
      unit: ''
    };
    this.currentAlgoId = '';
    this.currentTaskId = '';
  }

  async findAllSdk(params) {
      let id = sessionStorage.getItem("nodeId");

    let res:any = await findAllSdk({ userId: "", nodeId: id })
    if (res && res.success) {
      this.list1 = []
      res.data.forEach(item => {
        if(item.installed) {
          this.list1.push(item)
        }
      });
    }
  }

  async findByType() {
    let res:any = await findByType({})
    console.log(res,'findByType')
    if (res && res.success) {
      let list = res.data.RULECOMPUTEBETWEEN.map((i) => {
        let obj:any = {}
        obj.name = i.name
        obj.value = i.value
        return obj
      })
      this.baseObject.options2 = [...list]
    }
  }

  async getBaseList() {
    let res:any = await getTagList({})
    if (res && res.success) {
      let filter = res.data.filter(i => {
        return i.status === 0
      })
      let all:any = {
        id: '',
        name: '全部底库',
        value: ''
      }
      let list = filter.map(i => {
        let obj:any = {}
        obj.id = i.key
        obj.name = i.title
        obj.value = i.value
        return obj
      })
      this.baseObject.options3 = [...all, ...list]
    }
  }

  async findAll() {
    let res:any = await findAll({})
    if (res && res.success) {
      if (res.data && res.data.length !== 0) {
        let list = res.data.map(i => {
          let obj:any = {}
          obj.id = i.task.taskid
          obj.name = i.task.taskname
          obj.enable = i.task.enable
          obj.is_alarm = i.task.is_alarm
          obj.child = []
          if (i.sdks && i.sdks.length !== 0) {
            obj.child = i.sdks.map(j => {
              let t:any = {}
              t.id = j.id
              t.ipc_id = j.ipc_id
              if (i.sdks.length == 1) {
                t.sdk_name = i.task.taskname
                console.log("单个sdk算法：",t.sdk_name)
              } else {
                t.sdk_name = j.sdk_name
                console.log("多个sdk算法：",t.sdk_name)
              }
              t.icon = j.icon
              t.enable = j.enable
              t.isSelect = false
              return t
            })
          }
          obj.isSetting = false
          obj.isShowSetAlgo = false
          return obj
        })
        this.list2 = list
      }
    }
  }
}